#include <algorithm>
#include <format>
#include <functional>
#include <iostream>
#include <ranges>
#include <set>
#include <vector>

/*
* The three-way comparison operator works like this:
*	(a <=> b) < 0 if a < b
*	(a <=> b) > 0 if a > b
*	(a <=> b) == 0 if a and b are equal/equivalent.
*/

struct Point
{
	int x_ = 0;
	int y_ = 0;
	int z_ = 0;

	// TODO implement the comparisons operator such as Point objects are lexicographically comparable
};

void comparePoints()
{
	std::cout << "comparePoints\n";

	// Designated initializers allows to specify the fields by name
	Point lower{ .x_ = 1, .y_ = 2 };
	Point higher{ .x_ = 3, .y_ = 4 };

	// All of these are generated by the compiler
	std::cout << "lower(1, 2) < higher(3, 4): " << std::boolalpha << (lower < higher) << "\n";
	std::cout << "lower(1, 2) <= higher(3, 4): " << std::boolalpha << (lower <= higher) << "\n";
	std::cout << "lower(1, 2) > higher(3, 4): " << std::boolalpha << (lower > higher) << "\n";
	std::cout << "lower(1, 2) >= higher(3, 4): " << std::boolalpha << (lower >= higher) << "\n";
	std::cout << "lower(1, 2) == higher(3, 4): " << std::boolalpha << (lower == higher) << "\n";
	std::cout << "lower(1, 2) != higher(3, 4): " << std::boolalpha << (lower != higher) << "\n";

	std::cout << "\n";

	std::cout << "lower(1, 2) < lower(1, 2): " << std::boolalpha << (lower < lower) << "\n";
	std::cout << "lower(1, 2) <= lower(1, 2): " << std::boolalpha << (lower <= lower) << "\n";
	std::cout << "lower(1, 2) > lower(1, 2): " << std::boolalpha << (lower > lower) << "\n";
	std::cout << "lower(1, 2) >= lower(1, 2): " << std::boolalpha << (lower >= lower) << "\n";
	std::cout << "lower(1, 2) == lower(1, 2): " << std::boolalpha << (lower == lower) << "\n";
	std::cout << "lower(1, 2) != lower(1, 2): " << std::boolalpha << (lower != lower) << "\n";

	std::cout << "\n";
}

struct Student
{
	int id_;
	std::string first_name_;
	std::string last_name_;
	std::string enrollment_date_;

	// TODO implement the comparison operators that will allow to compare Students in order of their
	// last_name_
	// first_name_
	// id_

	void print() const
	{
		auto output = std::format("{0} {1}, id: {2}, Enrolled since: {3}", first_name_, last_name_, id_, enrollment_date_);
		std::cout << output << "\n";
	}
};

void compareStudents()
{
	std::cout << "compareStudents\n";

	// Designated initializers allows to specify the fields by name
	Student first{ .id_ = 1, .first_name_ = "John", .last_name_ = "Doe", .enrollment_date_ = "2020-01-01" };
	Student second{ .id_ = 2, .first_name_ = "Martin", .last_name_ = "Smith", .enrollment_date_ = "2022-02-12" };
	Student third{ .id_ = 3, .first_name_ = "John", .last_name_ = "Stern", .enrollment_date_ = "2023-06-06" };
	Student fourth{ .id_ = 4, .first_name_ = "John", .last_name_ = "Doe", .enrollment_date_ = "2023-07-07" };
	std::vector<Student> students{ first, second, third, fourth };

	std::cout << "Students before sorting:\n";
	for (const auto& student : students)
	{
		student.print();
	}

	std::cout << "\n";

	// Possible since operator< is defaulted
	std::set<Student> student_set{ first, second, third, fourth };

	std::cout << "Students in set:\n";
	for (const auto& student : student_set)
	{
		student.print();
	}

	// Possible since operator< is defaulted
	std::ranges::sort(students);

	std::cout << "Students after sorting:\n";
	for (const auto& student : students)
	{
		student.print();
	}

	// Possible since operator!= is defaulted in terms of operator==
	std::cout << "Are both John Doe different student? " << std::boolalpha << (first != fourth) << "\n";

	std::cout << "\n";
}

int main()
{
	std::cout << "Hello Three Way Operator!\n";

	comparePoints();
	compareStudents();
}
